package immibis.ars;

import java.util.List;
import java.util.ArrayList;

import net.minecraft.src.*;
import immibis.ars.beams.LogicType;
import immibis.core.api.porting.SidedProxy;
import immibis.core.aspects.ClientOnly;

public class ItemComponent extends Item {
	
	public static final int META_ENERGY_MODULATOR = 0;
	public static final int META_DIAMOND_LENS = 1;
	public static final int META_PROJECTOR_BASE = 2;
	
	private String[] internal_names;

	public ItemComponent(int id_minus256) {
		super(id_minus256);
		
		String[] names = new String[] {
			"Energy modulator",
			"Diamond lens",
			"Forcefield projector base"
		};
		
		setMaxDamage(0);
        setHasSubtypes(true);
        
        /* $if mc > 1.3$ */
        setCreativeTab(CreativeTabs.tabMisc);
        /* $endif$ */
        
        internal_names = new String[names.length];
        for(int k = 0; k < names.length && k < 16; k++)
        {
        	internal_names[k] = "ARS-component."+k;
        	SidedProxy.instance.addLocalization(internal_names[k] + ".name", names[k]);
        }
        
		setTextureFile("/immibis/ars/textures/items.png");
	}
	
	@Override
	public String getItemNameIS(ItemStack is) {
		try {
			return internal_names[is.getItemDamage()];
		} catch(ArrayIndexOutOfBoundsException e) {
			return "";
		}
	}
	
	/* $if jclient$ */
	@ClientOnly
	@Override
	public int getIconFromDamage(int damage) {
		return 32 + damage;
	}
	/* $endif$ */
	
	@Override
	/* $if mc < 1.3$
	public void addCreativeItems(ArrayList list) {
	$else$ */
	public void getSubItems(int id, net.minecraft.src.CreativeTabs tab, List list) {
	/* $endif$ */
		for(int meta = 0; meta < 3; meta++)
			list.add(new ItemStack(this, 1, meta));
	}

}
